deploy.sh 22.4 KB
Newer Older
1 2 3 4 5 6 7 8 9 10 11
#!/bin/bash

# Deploy script to install provisioning server for OPNFV Apex
# author: Dan Radez (dradez@redhat.com)
# author: Tim Rozet (trozet@redhat.com)
#
# Based on RDO Manager http://www.rdoproject.org

set -e

##VARIABLES
12 13 14 15 16 17 18 19 20 21 22
if [ "$TERM" != "unknown" ]; then
  reset=$(tput sgr0)
  blue=$(tput setaf 4)
  red=$(tput setaf 1)
  green=$(tput setaf 2)
else
  reset=""
  blue=""
  red=""
  green=""
fi
23

Tim Rozet's avatar
Tim Rozet committed
24
vm_index=4
Dan Radez's avatar
Dan Radez committed
25
ha_enabled="TRUE"
Dan Radez's avatar
Dan Radez committed
26 27
ping_site="8.8.8.8"
ntp_server="pool.ntp.org"
28 29
net_isolation_enabled="TRUE"

30 31
declare -i CNT
declare UNDERCLOUD
32
declare -A deploy_options_array
33

34
SSH_OPTIONS=(-o StrictHostKeyChecking=no -o GlobalKnownHostsFile=/dev/null -o UserKnownHostsFile=/dev/null -o LogLevel=error)
35 36 37
DEPLOY_OPTIONS=""
RESOURCES=/var/opt/opnfv/stack
CONFIG=/var/opt/opnfv
38 39
INSTACKENV=$CONFIG/instackenv.json
NETENV=$CONFIG/network-environment.yaml
40

41
##FUNCTIONS
42 43 44 45 46 47 48 49 50 51 52 53 54 55 56 57 58 59 60 61 62 63 64 65 66 67 68 69 70 71 72 73 74 75 76 77 78 79 80 81 82 83 84 85 86 87 88 89 90 91 92 93 94 95 96 97 98 99 100 101 102 103 104 105 106 107 108 109 110 111 112 113 114 115 116 117 118 119 120 121 122 123 124 125 126 127 128 129 130 131 132 133 134 135 136 137 138 139 140 141 142 143 144 145 146 147 148 149 150 151
##translates yaml into variables
##params: filename, prefix (ex. "config_")
##usage: parse_yaml opnfv_ksgen_settings.yml "config_"
parse_yaml() {
   local prefix=$2
   local s='[[:space:]]*' w='[a-zA-Z0-9_]*' fs=$(echo @|tr @ '\034')
   sed -ne "s|^\($s\)\($w\)$s:$s\"\(.*\)\"$s\$|\1$fs\2$fs\3|p" \
        -e "s|^\($s\)\($w\)$s:$s\(.*\)$s\$|\1$fs\2$fs\3|p"  $1 |
   awk -F$fs '{
      indent = length($1)/2;
      vname[indent] = $2;
      for (i in vname) {if (i > indent) {delete vname[i]}}
      if (length($3) > 0) {
         vn=""; for (i=0; i<indent; i++) {vn=(vn)(vname[i])("_")}
         printf("%s%s%s=\"%s\"\n", "'$prefix'",vn, $2, $3);
      }
   }'
}

##checks if prefix exists in string
##params: string, prefix
##usage: contains_prefix "deploy_setting_launcher=1" "deploy_setting"
contains_prefix() {
  local mystr=$1
  local prefix=$2
  if echo $mystr | grep -E "^$prefix.*$" > /dev/null; then
    return 0
  else
    return 1
  fi
}
##parses variable from a string with '='
##and removes global prefix
##params: string, prefix
##usage: parse_setting_var 'deploy_myvar=2' 'deploy_'
parse_setting_var() {
  local mystr=$1
  local prefix=$2
  if echo $mystr | grep -E "^.+\=" > /dev/null; then
    echo $(echo $mystr | grep -Eo "^.+\=" | tr -d '=' |  sed 's/^'"$prefix"'//')
  else
    return 1
  fi
}
##parses value from a string with '='
##params: string
##usage: parse_setting_value
parse_setting_value() {
  local mystr=$1
  echo $(echo $mystr | grep -Eo "\=.*$" | tr -d '=')
}
##parses deploy settings yaml into globals and options array
##params: none
##usage:  parse_deploy_settings
parse_deploy_settings() {
  local global_prefix="deploy_global_params_"
  local options_prefix="deploy_deploy_options_"
  local myvar myvalue
  local settings=$(parse_yaml $DEPLOY_SETTINGS_FILE "deploy_")

  for this_setting in $settings; do
    if contains_prefix $this_setting $global_prefix; then
      myvar=$(parse_setting_var $this_setting $global_prefix)
      if [ -z "$myvar" ]; then
        echo -e "${red}ERROR: while parsing ${DEPLOY_SETTINGS_FILE} for setting: ${this_setting}${reset}"
      fi
      myvalue=$(parse_setting_value $this_setting)
      # Do not override variables set by cmdline
      if [ -z "$(eval echo \$$myvar)" ]; then
        eval "$myvar=\$myvalue"
        echo -e "${blue}Global parameter set: ${myvar}:${myvalue}${reset}"
      else
        echo -e "${blue}Global parameter already set: ${myvar}${reset}"
      fi
    elif contains_prefix $this_setting $options_prefix; then
      myvar=$(parse_setting_var $this_setting $options_prefix)
      if [ -z "$myvar" ]; then
        echo -e "${red}ERROR: while parsing ${DEPLOY_SETTINGS_FILE} for setting: ${this_setting}${reset}"
      fi
      myvalue=$(parse_setting_value $this_setting)
      deploy_options_array[$myvar]=$myvalue
      echo -e "${blue}Deploy option set: ${myvar}:${myvalue}${reset}"
    fi
  done
}
##parses baremetal yaml settings into compatible json
##writes the json to $CONFIG/instackenv_tmp.json
##params: none
##usage: parse_inventory_file
parse_inventory_file() {
  local inventory=$(parse_yaml $INVENTORY_FILE)
  local node_list
  local node_prefix="node"
  local node_count=0
  local node_total
  local inventory_list

  # detect number of nodes
  for entry in $inventory; do
    if echo $entry | grep -Eo "^nodes_node[0-9]+_" > /dev/null; then
      this_node=$(echo $entry | grep -Eo "^nodes_node[0-9]+_")
      if [[ $inventory_list != *"$this_node"* ]]; then
        inventory_list+="$this_node "
      fi
    fi
  done

  inventory_list=$(echo $inventory_list | sed 's/ $//')

  for node in $inventory_list; do
Dan Radez's avatar
Dan Radez committed
152
    ((node_count+=1))
153 154 155 156 157 158 159 160 161 162 163 164 165 166 167 168 169 170 171 172 173
  done

  node_total=$node_count

  if [[ "$node_total" -lt 5 && ha_enabled == "TRUE" ]]; then
    echo -e "${red}ERROR: You must provide at least 5 nodes for HA baremetal deployment${reset}"
    exit 1
  elif [[ "$node_total" -lt 2 ]]; then
    echo -e "${red}ERROR: You must provide at least 2 nodes for non-HA baremetal deployment${reset}"
    exit 1
  fi

  eval $(parse_yaml $INVENTORY_FILE)

  instack_env_output="
{
 \"nodes\" : [

"
  node_count=0
  for node in $inventory_list; do
Dan Radez's avatar
Dan Radez committed
174 175
    ((node_count+=1))
    node_output="
176 177 178 179 180 181 182 183 184 185 186 187 188
        {
          \"pm_password\": \"$(eval echo \${${node}ipmi_pass})\",
          \"pm_type\": \"pxe_ipmitool\",
          \"mac\": [
            \"$(eval echo \${${node}mac_address})\"
          ],
          \"cpu\": \"$(eval echo \${${node}cpus})\",
          \"memory\": \"$(eval echo \${${node}memory})\",
          \"disk\": \"$(eval echo \${${node}disk})\",
          \"arch\": \"$(eval echo \${${node}arch})\",
          \"pm_user\": \"$(eval echo \${${node}ipmi_user})\",
          \"pm_addr\": \"$(eval echo \${${node}ipmi_ip})\"
"
Dan Radez's avatar
Dan Radez committed
189
    instack_env_output+=${node_output}
190 191 192 193 194 195 196 197 198 199 200 201 202
    if [ $node_count -lt $node_total ]; then
      instack_env_output+="        },"
    else
      instack_env_output+="        }"
    fi
  done

  instack_env_output+='
  ]
}
'
  #Copy instackenv.json to undercloud for baremetal
  echo -e "{blue}Parsed instackenv JSON:\n${instack_env_output}${reset}"
Dan Radez's avatar
Dan Radez committed
203
  ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
204 205 206 207 208 209
cat > instackenv.json << EOF
$instack_env_output
EOF
EOI

}
210 211 212
##verify internet connectivity
#params: none
function verify_internet {
Dan Radez's avatar
Dan Radez committed
213
  if ping -c 2 $ping_site > /dev/null; then
214 215 216 217 218 219 220 221 222 223 224 225 226 227 228 229 230 231 232
    if ping -c 2 www.google.com > /dev/null; then
      echo "${blue}Internet connectivity detected${reset}"
      return 0
    else
      echo "${red}Internet connectivity detected, but DNS lookup failed${reset}"
      return 1
    fi
  else
    echo "${red}No internet connectivity detected${reset}"
    return 1
  fi
}

##download dependencies if missing and configure host
#params: none
function configure_deps {
  if ! verify_internet; then
    echo "${red}Will not download dependencies${reset}"
    internet=false
Dan Radez's avatar
Dan Radez committed
233 234 235 236 237 238
  fi

  # verify ip forwarding
  if sysctl net.ipv4.ip_forward | grep 0; then
    sudo sysctl -w net.ipv4.ip_forward=1
    sudo sh -c "echo 'net.ipv4.ip_forward = 1' >> /etc/sysctl.conf"
239 240
  fi

Dan Radez's avatar
Dan Radez committed
241
  # ensure brbm networks are configured
242 243 244 245
  systemctl start openvswitch
  ovs-vsctl list-br | grep brbm > /dev/null || ovs-vsctl add-br brbm
  virsh net-list --all | grep brbm > /dev/null || virsh net-create $CONFIG/brbm-net.xml
  virsh net-list | grep -E "brbm\s+active" > /dev/null || virsh net-start brbm
Dan Radez's avatar
Dan Radez committed
246 247 248
  ovs-vsctl list-br | grep brbm1 > /dev/null || ovs-vsctl add-br brbm1
  virsh net-list --all | grep brbm1 > /dev/null || virsh net-create $CONFIG/brbm1-net.xml
  virsh net-list | grep -E "brbm1\s+active" > /dev/null || virsh net-start brbm1
249 250 251 252 253 254 255 256 257 258 259 260 261 262 263 264 265 266 267 268 269 270 271

  # ensure storage pool exists and is started
  virsh pool-list --all | grep default > /dev/null || virsh pool-create $CONFIG/default-pool.xml
  virsh pool-list | grep -Eo "default\s+active" > /dev/null || virsh pool-start default

  if virsh net-list | grep default > /dev/null; then
    num_ints_same_subnet=$(ip addr show | grep "inet 192.168.122" | wc -l)
    if [ "$num_ints_same_subnet" -gt 1 ]; then
      virsh net-destroy default
      ##go edit /etc/libvirt/qemu/networks/default.xml
      sed -i 's/192.168.122/192.168.123/g' /etc/libvirt/qemu/networks/default.xml
      sed -i 's/192.168.122/192.168.123/g' instackenv-virt.json
      sleep 5
      virsh net-start default
      virsh net-autostart default
    fi
  fi

  if ! egrep '^flags.*(vmx|svm)' /proc/cpuinfo > /dev/null; then
    echo "${red}virtualization extensions not found, kvm kernel module insertion may fail.\n  \
Are you sure you have enabled vmx in your bios or hypervisor?${reset}"
  fi

Dan Radez's avatar
Dan Radez committed
272 273
  if ! lsmod | grep kvm > /dev/null; then modprobe kvm; fi
  if ! lsmod | grep kvm_intel > /dev/null; then modprobe kvm_intel; fi
274 275 276 277 278 279 280 281 282 283 284 285 286

  if ! lsmod | grep kvm > /dev/null; then
    echo "${red}kvm kernel modules not loaded!${reset}"
    return 1
  fi

  ##sshkeygen for root
  if [ ! -e ~/.ssh/id_rsa.pub ]; then
    ssh-keygen -t rsa -N "" -f ~/.ssh/id_rsa
  fi

  echo "${blue}All dependencies installed and running${reset}"
}
287 288

##verify vm exists, an has a dhcp lease assigned to it
Dan Radez's avatar
Dan Radez committed
289
##params: none
290
function setup_instack_vm {
291
  if ! virsh list --all | grep instack > /dev/null; then
292
      #virsh vol-create default instack.qcow2.xml
293
      virsh define $CONFIG/instack.xml
294

295 296 297 298
      #Upload instack image
      #virsh vol-create default --file instack.qcow2.xml
      virsh vol-create-as default instack.qcow2 30G --format qcow2

299 300 301 302 303 304 305 306 307 308
      ### this doesn't work for some reason I was getting hangup events so using cp instead
      #virsh vol-upload --pool default --vol instack.qcow2 --file $CONFIG/stack/instack.qcow2
      #2015-12-05 12:57:20.569+0000: 8755: info : libvirt version: 1.2.8, package: 16.el7_1.5 (CentOS BuildSystem <http://bugs.centos.org>, 2015-11-03-13:56:46, worker1.bsys.centos.org)
      #2015-12-05 12:57:20.569+0000: 8755: warning : virKeepAliveTimerInternal:143 : No response from client 0x7ff1e231e630 after 6 keepalive messages in 35 seconds
      #2015-12-05 12:57:20.569+0000: 8756: warning : virKeepAliveTimerInternal:143 : No response from client 0x7ff1e231e630 after 6 keepalive messages in 35 seconds
      #error: cannot close volume instack.qcow2
      #error: internal error: received hangup / error event on socket
      #error: Reconnected to the hypervisor

      cp -f $RESOURCES/instack.qcow2 /var/lib/libvirt/images/instack.qcow2
309 310 311 312

  else
      echo "Found Instack VM, using existing VM"
  fi
313 314 315 316

  # if the VM is not running update the authkeys and start it
  if ! virsh list | grep instack > /dev/null; then
    echo "Injecting ssh key to instack VM"
317 318
    virt-customize -c qemu:///system -d instack --run-command "mkdir /root/.ssh/" \
        --upload ~/.ssh/id_rsa.pub:/root/.ssh/authorized_keys \
319 320 321 322 323 324
        --run-command "chmod 600 /root/.ssh/authorized_keys && restorecon /root/.ssh/authorized_keys" \
        --run-command "cp /root/.ssh/authorized_keys /home/stack/.ssh/" \
        --run-command "chown stack:stack /home/stack/.ssh/authorized_keys && chmod 600 /home/stack/.ssh/authorized_keys"
    virsh start instack
  fi

325 326 327
  sleep 3 # let DHCP happen

  CNT=10
328 329
  echo -n "${blue}Waiting for instack's dhcp address${reset}"
  while ! grep instack /var/lib/libvirt/dnsmasq/default.leases > /dev/null && [ $CNT -gt 0 ]; do
330 331 332 333 334 335
      echo -n "."
      sleep 3
      CNT=CNT-1
  done

  # get the instack VM IP
336
  UNDERCLOUD=$(grep instack /var/lib/libvirt/dnsmasq/default.leases | awk '{print $3}' | head -n 1)
Dan Radez's avatar
Dan Radez committed
337
  if [ -z "$UNDERCLOUD" ]; then
338 339 340 341 342 343 344 345 346
    #if not found then dnsmasq may be using leasefile-ro
    instack_mac=$(virsh domiflist instack | grep default | \
                  grep -Eo "[0-9a-f\]+:[0-9a-f\]+:[0-9a-f\]+:[0-9a-f\]+:[0-9a-f\]+:[0-9a-f\]+")
    UNDERCLOUD=$(arp -e | grep ${instack_mac} | awk {'print $1'})

    if [ -z "$UNDERCLOUD" ]; then
      echo "\n\nNever got IP for Instack. Can Not Continue."
      exit 1
    fi
Dan Radez's avatar
Dan Radez committed
347 348 349
  else
     echo -e "${blue}\rInstack VM has IP $UNDERCLOUD${reset}"
  fi
350 351

  CNT=10
352
  echo -en "${blue}\rValidating instack VM connectivity${reset}"
353 354 355
  while ! ping -c 1 $UNDERCLOUD > /dev/null && [ $CNT -gt 0 ]; do
      echo -n "."
      sleep 3
356
      CNT=$CNT-1
357
  done
Dan Radez's avatar
Dan Radez committed
358
  if [ "$CNT" -eq 0 ]; then
Dan Radez's avatar
Dan Radez committed
359 360 361
      echo "Failed to contact Instack. Can Not Continue"
      exit 1
  fi
362
  CNT=10
363
  while ! ssh -T ${SSH_OPTIONS[@]} "root@$UNDERCLOUD" "echo ''" 2>&1> /dev/null && [ $CNT -gt 0 ]; do
364 365
      echo -n "."
      sleep 3
366
      CNT=$CNT-1
367
  done
Dan Radez's avatar
Dan Radez committed
368
  if [ "$CNT" -eq 0 ]; then
Dan Radez's avatar
Dan Radez committed
369 370 371
      echo "Failed to connect to Instack. Can Not Continue"
      exit 1
  fi
372 373

  # extra space to overwrite the previous connectivity output
Dan Radez's avatar
Dan Radez committed
374
  echo -e "${blue}\r                                                                 ${reset}"
375

Dan Radez's avatar
Dan Radez committed
376 377 378
  #add the instack brbm1 interface
  virsh attach-interface --domain instack --type network --source brbm1 --model rtl8139 --config --live
  sleep 1
Dan Radez's avatar
Dan Radez committed
379
  ssh -T ${SSH_OPTIONS[@]} "root@$UNDERCLOUD" "if ! ip a s eth2 | grep 192.168.37.1 > /dev/null; then ip a a 192.168.37.1/24 dev eth2; ip link set up dev eth2; fi"
Dan Radez's avatar
Dan Radez committed
380

381 382 383
  # ssh key fix for stack user
  ssh -T ${SSH_OPTIONS[@]} "root@$UNDERCLOUD" "restorecon -r /home/stack"
}
384

Tim Rozet's avatar
Tim Rozet committed
385 386
##Create virtual nodes in virsh
##params: none
387 388
function setup_virtual_baremetal {
  for i in $(seq 0 $vm_index); do
Dan Radez's avatar
Dan Radez committed
389 390 391
    if ! virsh list --all | grep baremetalbrbm_brbm1_${i} > /dev/null; then
      if [ ! -e $CONFIG/baremetalbrbm_brbm1_${i}.xml ]; then
        define_virtual_node baremetalbrbm_brbm1_${i}
Tim Rozet's avatar
Tim Rozet committed
392
      fi
Dan Radez's avatar
Dan Radez committed
393
      virsh define $CONFIG/baremetalbrbm_brbm1_${i}.xml
394 395 396
    else
      echo "Found Baremetal ${i} VM, using existing VM"
    fi
Dan Radez's avatar
Dan Radez committed
397
    virsh vol-list default | grep baremetalbrbm_brbm1_${i} 2>&1> /dev/null || virsh vol-create-as default baremetalbrbm_brbm1_${i}.qcow2 40G --format qcow2
398
  done
399

400 401 402
}

##Copy over the glance images and instack json file
Tim Rozet's avatar
Tim Rozet committed
403
##params: none
404
function copy_materials_to_instack {
405

406 407
  echo
  echo "Copying configuration file and disk images to instack"
408
  scp ${SSH_OPTIONS[@]} $RESOURCES/overcloud-full.qcow2 "stack@$UNDERCLOUD":
409
  scp ${SSH_OPTIONS[@]} $NETENV "stack@$UNDERCLOUD":
Dan Radez's avatar
Dan Radez committed
410
  scp ${SSH_OPTIONS[@]} -r $CONFIG/nics/ "stack@$UNDERCLOUD":
411

412
  if [[ ${#deploy_options_array[@]} -eq 0 || ${deploy_options_array['sdn_controller']} == 'opendaylight' ]]; then
Dan Radez's avatar
Dan Radez committed
413 414 415
    DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/opendaylight.yaml"
  elif [ ${deploy_options_array['sdn_controller']} == 'opendaylight-external' ]; then
    DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/opendaylight-external.yaml"
416 417 418 419 420 421 422
  elif [ ${deploy_options_array['sdn_controller']} == 'onos' ]; then
    echo -e "${red}ERROR: ONOS is currently unsupported...exiting${reset}"
    exit 1
  elif [ ${deploy_options_array['sdn_controller']} == 'opencontrail' ]; then
    echo -e "${red}ERROR: OpenContrail is currently unsupported...exiting${reset}"
    exit 1
  fi
423 424 425 426

  # ensure stack user on instack machine has an ssh key
  ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" "if [ ! -e ~/.ssh/id_rsa.pub ]; then ssh-keygen -t rsa -N '' -f ~/.ssh/id_rsa; fi"

427
  if [ "$virtual" == "TRUE" ]; then
428 429 430 431 432 433

      # copy the instack vm's stack user's pub key to
      # root's auth keys so that instack can control
      # vm power on the hypervisor
      ssh ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" "cat /home/stack/.ssh/id_rsa.pub" >> /root/.ssh/authorized_keys

434 435 436 437 438 439 440
      # fix MACs to match new setup
      for i in $(seq 0 $vm_index); do
        pyscript="import json
data = json.load(open('$CONFIG/instackenv-virt.json'))
print data['nodes'][$i]['mac'][0]"

        old_mac=$(python -c "$pyscript")
Dan Radez's avatar
Dan Radez committed
441
        new_mac=$(virsh dumpxml baremetalbrbm_brbm1_$i | grep "mac address" | cut -d = -f2 | grep -Eo "[0-9a-f:]+")
442
        # this doesn't work with multiple vnics on the vms
Dan Radez's avatar
Dan Radez committed
443 444 445 446
        #if [ "$old_mac" != "$new_mac" ]; then
        #  echo "${blue}Modifying MAC for node from $old_mac to ${new_mac}${reset}"
        #  sed -i 's/'"$old_mac"'/'"$new_mac"'/' $CONFIG/instackenv-virt.json
        #fi
447 448
      done

449
      DEPLOY_OPTIONS+=" --libvirt-type qemu"
450 451
      INSTACKENV=$CONFIG/instackenv-virt.json
      NETENV=$CONFIG/network-environment.yaml
452

453 454 455
      # upload instackenv file to Instack for virtual deployment
      scp ${SSH_OPTIONS[@]} $INSTACKENV "stack@$UNDERCLOUD":instackenv.json
  fi
456 457 458

  # allow stack to control power management on the hypervisor via sshkey
  # only if this is a virtual deployment
459
  if [ "$virtual" == "TRUE" ]; then
460 461 462 463 464 465 466 467 468 469 470
      ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
while read -r line; do
  stack_key=\${stack_key}\\\\\\\\n\${line}
done < <(cat ~/.ssh/id_rsa)
stack_key=\$(echo \$stack_key | sed 's/\\\\\\\\n//')
sed -i 's~INSERT_STACK_USER_PRIV_KEY~'"\$stack_key"'~' instackenv.json
EOI
  fi

# copy stack's ssh key to this users authorized keys
ssh -T ${SSH_OPTIONS[@]} "root@$UNDERCLOUD" "cat /home/stack/.ssh/id_rsa.pub" >> ~/.ssh/authorized_keys
471 472 473
}

##preping it for deployment and launch the deploy
Tim Rozet's avatar
Tim Rozet committed
474
##params: none
475
function undercloud_prep_overcloud_deploy {
476 477 478
# configure undercloud on Undercloud VM
ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" "openstack undercloud install > apex-undercloud-install.log"

Tim Rozet's avatar
Tim Rozet committed
479
  # check if HA is enabled
Dan Radez's avatar
Dan Radez committed
480
  if [ $ha_enabled == "TRUE" ]; then
Tim Rozet's avatar
Tim Rozet committed
481 482
     DEPLOY_OPTIONS+=" --control-scale 3 --compute-scale 2"
     DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/puppet-pacemaker.yaml"
483
     DEPLOY_OPTIONS+=" --ntp-server $ntp_server"
Tim Rozet's avatar
Tim Rozet committed
484
  fi
485

486 487 488
  if [ $net_isolation_enabled == "TRUE" ]; then
     DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/network-isolation.yaml"
     DEPLOY_OPTIONS+=" -e network-environment.yaml"
Dan Radez's avatar
Dan Radez committed
489
     DEPLOY_OPTIONS+=" --ntp-server $ntp_server"
490 491
  fi

492
  ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
493
source stackrc
494 495
set -o errexit
echo "Uploading overcloud glance images"
496
openstack overcloud image upload
497
echo "Configuring undercloud and discovering nodes"
498 499 500
openstack baremetal import --json instackenv.json
openstack baremetal configure boot
openstack baremetal introspection bulk start
501 502
echo "Configuring flavors"
openstack flavor list | grep baremetal || openstack flavor create --id auto --ram 4096 --disk 39 --vcpus 1 baremetal
503
openstack flavor set --property "cpu_arch"="x86_64" --property "capabilities:boot_option"="local" baremetal
504 505
echo "Configuring nameserver on ctlplane network"
neutron subnet-update \$(neutron subnet-list | grep -v id | grep -v \\\\-\\\\- | awk {'print \$2'}) --dns-nameserver 8.8.8.8
506
echo "Executing overcloud deployment, this should run for an extended period without output."
507
sleep 60 #wait for Hypervisor stats to check-in to nova
508
openstack overcloud deploy --templates $DEPLOY_OPTIONS
509 510 511 512 513
EOI

}

display_usage() {
Dan Radez's avatar
Dan Radez committed
514 515
  echo -e "Usage:\n$0 [arguments] \n"
  echo -e "   -c|--config : Directory to configuration files. Optional.  Defaults to /var/opt/opnfv/ \n"
516 517 518
  echo -e "   -d|--deploy-settings : Full path to deploy settings yaml file. Optional.  Defaults to null \n"
  echo -e "   -i|--inventory : Full path to inventory yaml file. Required only for baremetal \n"
  echo -e "   -n|--netenv : Full path to network environment file. Optional. Defaults to \$CONFIG/network-environment.yaml \n"
Dan Radez's avatar
Dan Radez committed
519 520 521
  echo -e "   -p|--ping-site : site to use to verify IP connectivity. Optional. Defaults to 8.8.8.8 \n"
  echo -e "   -r|--resources : Directory to deployment resources. Optional.  Defaults to /var/opt/opnfv/stack \n"
  echo -e "   -v|--virtual : Virtualize overcloud nodes instead of using baremetal. \n"
522
  echo -e "   --no-ha : disable High Availability deployment scheme, this assumes a single controller and single compute node \n"
523
  echo -e "   --flat : disable Network Isolation and use a single flat network for the underlay network."
524 525
}

526
##translates the command line parameters into variables
527 528 529 530 531 532 533
##params: $@ the entire command line is passed
##usage: parse_cmd_line() "$@"
parse_cmdline() {
  echo -e "\n\n${blue}This script is used to deploy the Apex Installer and Provision OPNFV Target System${reset}\n\n"
  echo "Use -h to display help"
  sleep 2

Dan Radez's avatar
Dan Radez committed
534
  while [ "${1:0:1}" = "-" ]
535 536
  do
    case "$1" in
537 538 539 540 541 542
        -h|--help)
                display_usage
                exit 0
            ;;
        -c|--config)
                CONFIG=$2
543
                echo "Deployment Configuration Directory Overridden to: $2"
544 545
                shift 2
            ;;
546 547 548 549 550 551 552
        -d|--deploy-settings)
                DEPLOY_SETTINGS_FILE=$2
                echo "Deployment Configuration file: $2"
                shift 2
            ;;
        -i|--inventory)
                INVENTORY_FILE=$2
553 554 555 556 557 558 559 560
                shift 2
            ;;
        -n|--netenv)
                NETENV=$2
                shift 2
            ;;
        -p|--ping-site)
                ping_site=$2
561
                echo "Using $2 as the ping site"
562 563
                shift 2
            ;;
564 565
        -r|--resources)
                RESOURCES=$2
566
                echo "Deployment Resources Directory Overridden to: $2"
567
                shift 2
568
            ;;
569
        -v|--virtual)
570
                virtual="TRUE"
571
                echo "Executing a Virtual Deployment"
572 573
                shift 1
            ;;
574
        --no-ha )
575 576
                ha_enabled="FALSE"
                echo "HA Deployment Disabled"
Tim Rozet's avatar
Tim Rozet committed
577
                shift 1
578
            ;;
579
        --flat )
580 581
                net_isolation_enabled="FALSE"
                echo "Underlay Network Isolation Disabled: using flat configuration"
582 583
                shift 1
            ;;
584 585 586 587 588 589
        *)
                display_usage
                exit 1
            ;;
    esac
  done
590 591

  if [[ ! -z "$NETENV" && "$net_isolation_enabled" == "FALSE" ]]; then
592
    echo -e "${red}INFO: Single flat network requested. Ignoring any netenv settings!${reset}"
593 594 595 596 597 598 599 600 601 602 603 604 605 606 607 608 609 610 611 612 613 614 615 616 617 618 619 620 621
  elif [[ ! -z "$NETENV" && ! -z "$DEPLOY_SETTINGS_FILE" ]]; then
    echo -e "${red}WARN: deploy_settings and netenv specified.  Ignoring netenv settings! deploy_settings will contain \
netenv${reset}"
  fi

  if [[ -n "$virtual" && -n "$INVENTORY_FILE" ]]; then
    echo -e "${red}ERROR: You should not specify an inventory with virtual deployments${reset}"
    exit 1
  fi

  if [[ ! -z "$DEPLOY_SETTINGS_FILE" && ! -f "$DEPLOY_SETTINGS_FILE" ]]; then
    echo -e "${red}ERROR: ${DEPLOY_SETTINGS_FILE} does not exist! Exiting...${reset}"
    exit 1
  fi

  if [[ ! -z "$NETENV" && ! -f "$NETENV" ]]; then
    echo -e "${red}ERROR: ${NETENV} does not exist! Exiting...${reset}"
    exit 1
  fi

  if [[ ! -z "$INVENTORY_FILE" && ! -f "$INVENTORY_FILE" ]]; then
    echo -e "{$red}ERROR: ${DEPLOY_SETTINGS_FILE} does not exist! Exiting...${reset}"
    exit 1
  fi

  if [[ -z "$virtual" && -z "$INVENTORY_FILE" ]]; then
    echo -e "${red}ERROR: You must specify an inventory file for baremetal deployments! Exiting...${reset}"
    exit 1
  fi
622 623 624 625 626 627
}

##END FUNCTIONS

main() {
  parse_cmdline "$@"
Dan Radez's avatar
Dan Radez committed
628 629 630
  if ! configure_deps; then
    echo "Dependency Validation Failed, Exiting."
  fi
631 632 633
  if [ -n "$DEPLOY_SETTINGS_FILE" ]; then
    parse_deploy_settings
  fi
634
  setup_instack_vm
635
  if [ "$virtual" == "TRUE" ]; then
636
    setup_virtual_baremetal
637 638
  elif [ -n "$INVENTORY_FILE" ]; then
    parse_inventory_file
639
  fi
640
  copy_materials_to_instack
641 642 643 644
  undercloud_prep_overcloud_deploy
}

main "$@"